#!/usr/bin/env python
from importlib import import_module
import os
from flask import Flask, render_template, Response
from RPi import GPIO
from pizypwm import *
from flask import request
import json
# import camera driver
if os.environ.get('CAMERA'):
    Camera = import_module('camera_' + os.environ['CAMERA']).Camera
else:
    from camera import Camera

# Raspberry Pi camera module (requires picamera package)
# from camera_pi import Camera
gazul = 100
gaz = PiZyPwm(100, 18, GPIO.BCM)
gaz.start(gazul)

gus0 = PiZyPwm(100, 17, GPIO.BCM)
gus1 = PiZyPwm(100, 22, GPIO.BCM)
gus2 = PiZyPwm(100, 27, GPIO.BCM)
gus3 = PiZyPwm(100, 23, GPIO.BCM)


gus0.start(0)
gus1.start(0)
gus2.start(0)
gus3.start(0)



app = Flask(__name__, static_folder='static', static_url_path='/static')


@app.route('/')
def index():
    """Video streaming home page."""
    return render_template('index.html')


def gen(camera):
    """Video streaming generator function."""
    while True:
        frame = camera.get_frame()
        yield (b'--frame\r\n'
               b'Content-Type: image/jpeg\r\n\r\n' + frame + b'\r\n')


@app.route('/video_feed')
def video_feed():
    """Video streaming route. Put this in the src attribute of an img tag."""
    return Response(gen(Camera()),
                    mimetype='multipart/x-mixed-replace; boundary=frame')



@app.route('/vpravo',methods=['GET', 'POST'])
def vpravo():
     nil = request.args['vpravo']
     fl = float(nil)  
     gazul = fl
     gaz.changeDutyCycle(gazul)
#     gazuli = request.args.get('vpravo')
#     gus0 = PiZyPwm(100, 17, GPIO.BCM)
 #    gus1 = PiZyPwm(100, 22, GPIO.BCM)
  #   gus2 = PiZyPwm(100, 27, GPIO.BCM)
   #  gus3 = PiZyPwm(100, 23, GPIO.BCM)
     gus0.changeDutyCycle(gazul)
     gus1.changeDutyCycle(0)
     gus2.changeDutyCycle(0)
     gus3.changeDutyCycle(gazul)
     print request.args['vpravo']
     print nil
     return 'VPRAVO'




@app.route('/vpravo1',methods=['GET', 'POST'])
def vpravo1():
     nil = request.args['vpravo']
     fl = float(nil)
     gazul = fl
     gaz.changeDutyCycle(gazul)
#     gazuli = request.args.get('vpravo')
#     gus0 = PiZyPwm(100, 17, GPIO.BCM)
 #    gus1 = PiZyPwm(100, 22, GPIO.BCM)
  #   gus2 = PiZyPwm(100, 27, GPIO.BCM)
   #  gus3 = PiZyPwm(100, 23, GPIO.BCM)
     gus0.changeDutyCycle(gazul)
     gus1.changeDutyCycle(0)
     gus2.changeDutyCycle(0)
     gus3.changeDutyCycle(gazul)
     time.sleep(0.01)
     gus0.changeDutyCycle(0)
     gus1.changeDutyCycle(0)
     gus2.changeDutyCycle(0)
     gus3.changeDutyCycle(0)


     print request.args['vpravo']
     print nil
     return 'VPRAVO_SMALL'





     
@app.route('/vlevo',methods=['GET', 'POST'])
def vlevo():

     nil = request.args['vlevo']
     fl = float(nil)
     gazul = fl
     gaz.changeDutyCycle(gazul)


     gus0.changeDutyCycle(0)
     gus1.changeDutyCycle(gazul)
     gus2.changeDutyCycle(gazul)
     gus3.changeDutyCycle(0)
     return 'VLEVO'





@app.route('/vlevo1',methods=['GET', 'POST'])
def vlevo1():

     nil = request.args['vlevo']
     fl = float(nil)
     gazul = fl
     gaz.changeDutyCycle(gazul)


     gus0.changeDutyCycle(0)
     gus1.changeDutyCycle(gazul)
     gus2.changeDutyCycle(gazul)
     gus3.changeDutyCycle(0)
     time.sleep(0.01)
     gus0.changeDutyCycle(0)
     gus1.changeDutyCycle(0)
     gus2.changeDutyCycle(0)
     gus3.changeDutyCycle(0)
 

     return 'VLEVO_SMALL'




@app.route('/vverh',methods=['GET', 'POST'])
def vverh():

     nil = request.args['vverh']
     fl = float(nil)
     gazul = fl
     gaz.changeDutyCycle(gazul)

     
     gus0.changeDutyCycle(gazul)
     gus1.changeDutyCycle(0)
     gus2.changeDutyCycle(gazul)
     gus3.changeDutyCycle(0)



     return 'VVERH'

@app.route('/vniz',methods=['GET', 'POST'])
def vniz():



     nil = request.args['vniz']
     fl = float(nil)
     gazul = fl
     gaz.changeDutyCycle(gazul)


     nil = request.args['vniz']
     fl = float(nil)
     gazul = fl
     gaz.changeDutyCycle(gazul)


     gus0.changeDutyCycle(0)
     gus1.changeDutyCycle(gazul)
     gus2.changeDutyCycle(0)
     gus3.changeDutyCycle(gazul)
     return 'VNIZ'

@app.route('/stop',methods=['GET', 'POST'])
def stop():

     gus0.changeDutyCycle(0)
     gus1.changeDutyCycle(0)
     gus2.changeDutyCycle(0)
     gus3.changeDutyCycle(0)


     return 'STOP'


if __name__ == '__main__':
    app.run(host='0.0.0.0', threaded=True)
